/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import javax.servlet.ServletConfig;
import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author Korisnik
 */
public class ServletContext1 extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code>
     * methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        try (
            PrintWriter out = response.getWriter()) {
            
            /* TODO output your page here. You may use following sample code. */
            out.println("<!DOCTYPE html>");
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet ServletServletContext1</title>");
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet ServletServletContext1 - Context params</h1>");
            
            Enumeration<String> contextAttributes = getServletContext().getAttributeNames();
            while (contextAttributes.hasMoreElements()) {
                String param = contextAttributes.nextElement();
                out.println("<h5>Context param: " + param + "</h5>");
                out.println("<h5>Context param value: " + getServletContext().getAttribute(param) + "</h5>");
            }
            
            out.println("<h1>Servlet ServletServletContext1 - Init params </h1>");
            Enumeration<String> initParams = getInitParameterNames();
            while (initParams.hasMoreElements()) {
                String param = initParams.nextElement();
                out.println("<h5>Init param: " + param + "</h5>");
                out.println("<h5>Init param value: " + getInitParameter(param) + "</h5>");
            }
            
            out.println("</body>");
            out.println("</html>");
        }
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    void setContextParam() {
        ServletContext servletContext = getServletContext();
        servletContext.setAttribute("sc1-param1", "servlet contex 1 - param 1");
        servletContext.setAttribute("sc1-param2", "servlet contex 1 - param 2");
        servletContext.setAttribute("sc1-param3", "servlet contex 1 - param 3");
    }
    

    @Override
    public void init(ServletConfig config) throws ServletException {
        super.init(config); //To change body of generated methods, choose Tools | Templates.
        setContextParam();
    }
    
}
